Index: /branches/OKB/HeuristicLab.Clients.OKB-3.3/Views/AlgorithmDataView.cs
===================================================================
--- /branches/OKB/HeuristicLab.Clients.OKB-3.3/Views/AlgorithmDataView.cs	(revision 4481)
+++ /branches/OKB/HeuristicLab.Clients.OKB-3.3/Views/AlgorithmDataView.cs	(revision 4481)
@@ -0,0 +1,201 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.IO;
+using System.Linq;
+using System.Windows.Forms;
+using HeuristicLab.Common;
+using HeuristicLab.Core.Views;
+using HeuristicLab.MainForm;
+using HeuristicLab.MainForm.WindowsForms;
+using HeuristicLab.Optimization;
+using HeuristicLab.Persistence.Default.Xml;
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Clients.OKB {
+  [View("AlgorithmData View")]
+  [Content(typeof(AlgorithmData), true)]
+  public partial class AlgorithmDataView : AsynchronousContentView {
+    public long AlgorithmId { get; set; }
+
+    public new AlgorithmData Content {
+      get { return (AlgorithmData)base.Content; }
+      set { base.Content = value; }
+    }
+
+    public AlgorithmDataView() {
+      InitializeComponent();
+    }
+
+    protected override void OnInitialized(System.EventArgs e) {
+      base.OnInitialized(e);
+      dataTypeComboBox.DataSource = Administrator.Instance.DataTypes.ToList();
+      dataTypeComboBox.SelectedIndex = -1;
+    }
+
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      if (Content == null) {
+        dataTypeComboBox.SelectedIndex = -1;
+        viewHost.Content = null;
+        noViewAvailableLabel.Visible = false;
+      } else {
+        dataTypeComboBox.SelectedItem = Administrator.Instance.DataTypes.FirstOrDefault(d => d.Id == Content.DataTypeId);
+
+        using (MemoryStream stream = new MemoryStream(Content.Data)) {
+          try {
+            viewHost.Content = XmlParser.Deserialize<IContent>(stream);
+            noViewAvailableLabel.Visible = false;
+          }
+          catch (Exception) {
+            viewHost.Content = null;
+            noViewAvailableLabel.Visible = true;
+          }
+          stream.Close();
+        }
+      }
+      fileTextBox.Text = "-";
+    }
+
+    protected override void SetEnabledStateOfControls() {
+      base.SetEnabledStateOfControls();
+      storeDataButton.Enabled = saveFileButton.Enabled = Content != null;
+      dataTypeComboBox.Enabled = Content != null && viewHost.Content == null;
+      fileTextBox.Enabled = Content != null;
+      groupBox.Enabled = Content != null;
+    }
+
+    private void refreshDataButton_Click(object sender, EventArgs e) {
+      AlgorithmData data = Administrator.Instance.GetAlgorithmData(AlgorithmId);
+      Content = data;
+    }
+    private void storeDataButton_Click(object sender, EventArgs e) {
+      if (viewHost.Content != null) {
+        try {
+          using (MemoryStream stream = new MemoryStream()) {
+            IAlgorithm algorithm = viewHost.Content as IAlgorithm;
+            algorithm.Prepare(true);
+            algorithm.Problem = null;
+            XmlGenerator.Serialize(algorithm, stream);
+            stream.Close();
+            Content.Data = stream.ToArray();
+          }
+        }
+        catch (Exception ex) {
+          ErrorHandling.ShowErrorDialog(this, ex);
+        }
+      }
+      Administrator.Instance.UpdateAlgorithmData(Content);
+    }
+    private void newDataButton_Click(object sender, EventArgs e) {
+      using (TypeSelectorDialog dialog = new TypeSelectorDialog()) {
+        dialog.Caption = "Select Algorithm";
+        dialog.TypeSelector.Caption = "Available Algorithms";
+        dialog.TypeSelector.Configure(typeof(IAlgorithm), false, true);
+        if (dialog.ShowDialog(this) == DialogResult.OK) {
+          try {
+            if (Content == null) Content = new AlgorithmData { AlgorithmId = AlgorithmId, Data = new byte[0] };
+            viewHost.Content = (IContent)dialog.TypeSelector.CreateInstanceOfSelectedType();
+            DataType dataType = Administrator.Instance.DataTypes.FirstOrDefault(d => d.Name == viewHost.Content.GetType().AssemblyQualifiedName);
+            if (dataType == null) {
+              dataType = new DataType { Name = viewHost.Content.GetType().AssemblyQualifiedName, SqlName = "Blob" };
+              dataType.PlatformId = Administrator.Instance.Platforms.FirstOrDefault(p => p.Name == "HeuristicLab 3.3").Id;
+
+              Administrator.Instance.Store(dataType);
+              Administrator.Instance.DataTypes.Add(dataType);
+              dataTypeComboBox.DataSource = Administrator.Instance.DataTypes.OrderBy(d => d.Name).ToList();
+            }
+            dataTypeComboBox.SelectedItem = dataType;
+            dataTypeComboBox.Enabled = false;
+            fileTextBox.Text = "-";
+            noViewAvailableLabel.Visible = false;
+          }
+          catch (Exception ex) {
+            ErrorHandling.ShowErrorDialog(this, ex);
+          }
+        }
+      }
+    }
+    private void openFileButton_Click(object sender, EventArgs e) {
+      if (openFileDialog.ShowDialog(this) == DialogResult.OK) {
+        try {
+          if (Content == null) Content = new AlgorithmData { AlgorithmId = AlgorithmId, Data = new byte[0] };
+          IAlgorithm algorithm = null;
+          try {
+            algorithm = XmlParser.Deserialize<IAlgorithm>(openFileDialog.FileName);
+          }
+          catch (Exception) { }
+
+          if (algorithm != null) {
+            viewHost.Content = algorithm;
+            noViewAvailableLabel.Visible = false;
+            DataType dataType = Administrator.Instance.DataTypes.FirstOrDefault(d => d.Name == viewHost.Content.GetType().AssemblyQualifiedName);
+            if (dataType == null) {
+              dataType = new DataType { Name = viewHost.Content.GetType().AssemblyQualifiedName, SqlName = "Blob" };
+              dataType.PlatformId = Administrator.Instance.Platforms.FirstOrDefault(p => p.Name == "HeuristicLab 3.3").Id;
+
+              Administrator.Instance.Store(dataType);
+              Administrator.Instance.DataTypes.Add(dataType);
+              dataTypeComboBox.DataSource = Administrator.Instance.DataTypes.OrderBy(d => d.Name).ToList();
+            }
+            dataTypeComboBox.SelectedItem = dataType;
+          } else {
+            viewHost.Content = null;
+            noViewAvailableLabel.Visible = true;
+            using (FileStream stream = new FileStream(openFileDialog.FileName, FileMode.Open, FileAccess.Read)) {
+              byte[] bytes = new byte[stream.Length];
+              stream.Read(bytes, 0, bytes.Length);
+              stream.Close();
+              Content.Data = bytes;
+            }
+          }
+          dataTypeComboBox.Enabled = viewHost.Content == null;
+          fileTextBox.Text = openFileDialog.FileName;
+        }
+        catch (Exception ex) {
+          ErrorHandling.ShowErrorDialog(this, ex);
+        }
+      }
+    }
+    private void saveFileButton_Click(object sender, EventArgs e) {
+      if (saveFileDialog.ShowDialog(this) == DialogResult.OK) {
+        try {
+          if (viewHost.Content != null) {
+            XmlGenerator.Serialize(viewHost.Content, saveFileDialog.FileName);
+          } else {
+            using (FileStream stream = new FileStream(saveFileDialog.FileName, FileMode.Create, FileAccess.Write)) {
+              stream.Write(Content.Data, 0, Content.Data.Length);
+              stream.Close();
+            }
+          }
+          fileTextBox.Text = saveFileDialog.FileName;
+        }
+        catch (Exception ex) {
+          ErrorHandling.ShowErrorDialog(this, ex);
+        }
+      }
+    }
+    private void dataTypeComboBox_SelectedIndexChanged(object sender, EventArgs e) {
+      if (Content != null) Content.DataTypeId = ((DataType)dataTypeComboBox.SelectedItem).Id;
+    }
+  }
+}
Index: /branches/OKB/HeuristicLab.Clients.OKB-3.3/Views/AlgorithmView.Designer.cs
===================================================================
--- /branches/OKB/HeuristicLab.Clients.OKB-3.3/Views/AlgorithmView.Designer.cs	(revision 4480)
+++ /branches/OKB/HeuristicLab.Clients.OKB-3.3/Views/AlgorithmView.Designer.cs	(revision 4481)
@@ -45,4 +45,5 @@
     /// </summary>
     private void InitializeComponent() {
+      System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(AlgorithmView));
       this.platformLabel = new System.Windows.Forms.Label();
       this.platformComboBox = new System.Windows.Forms.ComboBox();
@@ -55,11 +56,5 @@
       this.refreshUsersButton = new System.Windows.Forms.Button();
       this.dataTabPage = new System.Windows.Forms.TabPage();
-      this.fileLabel = new System.Windows.Forms.Label();
-      this.storeDataButton = new System.Windows.Forms.Button();
-      this.fileTextBox = new System.Windows.Forms.TextBox();
-      this.openFileButton = new System.Windows.Forms.Button();
-      this.openFileDialog = new System.Windows.Forms.OpenFileDialog();
-      this.dataTypeLabel = new System.Windows.Forms.Label();
-      this.dataTypeComboBox = new System.Windows.Forms.ComboBox();
+      this.algorithmDataView = new HeuristicLab.Clients.OKB.AlgorithmDataView();
       ((System.ComponentModel.ISupportInitialize)(this.modifiedPictureBox)).BeginInit();
       this.tabControl.SuspendLayout();
@@ -135,5 +130,5 @@
       this.usersListBox.Enabled = false;
       this.usersListBox.FormattingEnabled = true;
-      this.usersListBox.Location = new System.Drawing.Point(6, 35);
+      this.usersListBox.Location = new System.Drawing.Point(6, 36);
       this.usersListBox.Name = "usersListBox";
       this.usersListBox.SelectionMode = System.Windows.Forms.SelectionMode.MultiSimple;
@@ -170,9 +165,9 @@
       // storeUsersButton
       // 
-      this.storeUsersButton.Location = new System.Drawing.Point(86, 6);
+      this.storeUsersButton.Image = ((System.Drawing.Image)(resources.GetObject("storeUsersButton.Image")));
+      this.storeUsersButton.Location = new System.Drawing.Point(36, 6);
       this.storeUsersButton.Name = "storeUsersButton";
-      this.storeUsersButton.Size = new System.Drawing.Size(75, 23);
+      this.storeUsersButton.Size = new System.Drawing.Size(24, 24);
       this.storeUsersButton.TabIndex = 1;
-      this.storeUsersButton.Text = "&Store";
       this.toolTip.SetToolTip(this.storeUsersButton, "Store Authorized Users");
       this.storeUsersButton.UseVisualStyleBackColor = true;
@@ -181,9 +176,9 @@
       // refreshUsersButton
       // 
+      this.refreshUsersButton.Image = ((System.Drawing.Image)(resources.GetObject("refreshUsersButton.Image")));
       this.refreshUsersButton.Location = new System.Drawing.Point(6, 6);
       this.refreshUsersButton.Name = "refreshUsersButton";
-      this.refreshUsersButton.Size = new System.Drawing.Size(75, 23);
+      this.refreshUsersButton.Size = new System.Drawing.Size(24, 24);
       this.refreshUsersButton.TabIndex = 0;
-      this.refreshUsersButton.Text = "&Refresh";
       this.toolTip.SetToolTip(this.refreshUsersButton, "Refresh Authorized Users");
       this.refreshUsersButton.UseVisualStyleBackColor = true;
@@ -192,10 +187,5 @@
       // dataTabPage
       // 
-      this.dataTabPage.Controls.Add(this.dataTypeComboBox);
-      this.dataTabPage.Controls.Add(this.openFileButton);
-      this.dataTabPage.Controls.Add(this.fileTextBox);
-      this.dataTabPage.Controls.Add(this.storeDataButton);
-      this.dataTabPage.Controls.Add(this.dataTypeLabel);
-      this.dataTabPage.Controls.Add(this.fileLabel);
+      this.dataTabPage.Controls.Add(this.algorithmDataView);
       this.dataTabPage.Location = new System.Drawing.Point(4, 22);
       this.dataTabPage.Name = "dataTabPage";
@@ -203,75 +193,19 @@
       this.dataTabPage.Size = new System.Drawing.Size(625, 266);
       this.dataTabPage.TabIndex = 1;
-      this.dataTabPage.Text = "Serialized Algorithm";
+      this.dataTabPage.Text = "Platform-Specific Algorithm Data";
       this.dataTabPage.UseVisualStyleBackColor = true;
       // 
-      // fileLabel
-      // 
-      this.fileLabel.AutoSize = true;
-      this.fileLabel.Location = new System.Drawing.Point(6, 38);
-      this.fileLabel.Name = "fileLabel";
-      this.fileLabel.Size = new System.Drawing.Size(26, 13);
-      this.fileLabel.TabIndex = 1;
-      this.fileLabel.Text = "&File:";
-      // 
-      // storeDataButton
-      // 
-      this.storeDataButton.Enabled = false;
-      this.storeDataButton.Location = new System.Drawing.Point(6, 6);
-      this.storeDataButton.Name = "storeDataButton";
-      this.storeDataButton.Size = new System.Drawing.Size(75, 23);
-      this.storeDataButton.TabIndex = 0;
-      this.storeDataButton.Text = "&Store";
-      this.toolTip.SetToolTip(this.storeDataButton, "Store Serialized Algorithm");
-      this.storeDataButton.UseVisualStyleBackColor = true;
-      this.storeDataButton.Click += new System.EventHandler(this.storeDataButton_Click);
-      // 
-      // fileTextBox
-      // 
-      this.fileTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
-      this.fileTextBox.Location = new System.Drawing.Point(69, 35);
-      this.fileTextBox.Name = "fileTextBox";
-      this.fileTextBox.ReadOnly = true;
-      this.fileTextBox.Size = new System.Drawing.Size(520, 20);
-      this.fileTextBox.TabIndex = 2;
-      // 
-      // openFileButton
-      // 
-      this.openFileButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
-      this.openFileButton.Location = new System.Drawing.Point(595, 32);
-      this.openFileButton.Name = "openFileButton";
-      this.openFileButton.Size = new System.Drawing.Size(24, 24);
-      this.openFileButton.TabIndex = 3;
-      this.openFileButton.Text = "...";
-      this.openFileButton.UseVisualStyleBackColor = true;
-      this.openFileButton.Click += new System.EventHandler(this.openFileButton_Click);
-      // 
-      // openFileDialog
-      // 
-      this.openFileDialog.FileName = "algorithm";
-      this.openFileDialog.Filter = "All Files (*.*)|*.*";
-      this.openFileDialog.Title = "Select Algorithm File";
-      // 
-      // dataTypeLabel
-      // 
-      this.dataTypeLabel.AutoSize = true;
-      this.dataTypeLabel.Location = new System.Drawing.Point(6, 64);
-      this.dataTypeLabel.Name = "dataTypeLabel";
-      this.dataTypeLabel.Size = new System.Drawing.Size(57, 13);
-      this.dataTypeLabel.TabIndex = 4;
-      this.dataTypeLabel.Text = "&DataType:";
-      // 
-      // dataTypeComboBox
-      // 
-      this.dataTypeComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
-      this.dataTypeComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
-      this.dataTypeComboBox.FormattingEnabled = true;
-      this.dataTypeComboBox.Location = new System.Drawing.Point(69, 61);
-      this.dataTypeComboBox.Name = "dataTypeComboBox";
-      this.dataTypeComboBox.Size = new System.Drawing.Size(550, 21);
-      this.dataTypeComboBox.TabIndex = 5;
-      this.dataTypeComboBox.SelectedIndexChanged += new System.EventHandler(this.dataTypeComboBox_SelectedIndexChanged);
+      // algorithmDataView
+      // 
+      this.algorithmDataView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.algorithmDataView.Caption = "AlgorithmData View";
+      this.algorithmDataView.Content = null;
+      this.algorithmDataView.Location = new System.Drawing.Point(6, 6);
+      this.algorithmDataView.Name = "algorithmDataView";
+      this.algorithmDataView.ReadOnly = false;
+      this.algorithmDataView.Size = new System.Drawing.Size(613, 254);
+      this.algorithmDataView.TabIndex = 0;
       // 
       // AlgorithmView
@@ -300,5 +234,4 @@
       this.usersTabPage.ResumeLayout(false);
       this.dataTabPage.ResumeLayout(false);
-      this.dataTabPage.PerformLayout();
       this.ResumeLayout(false);
       this.PerformLayout();
@@ -318,11 +251,5 @@
     private System.Windows.Forms.Button refreshUsersButton;
     private System.Windows.Forms.TabPage dataTabPage;
-    private System.Windows.Forms.ComboBox dataTypeComboBox;
-    private System.Windows.Forms.Button openFileButton;
-    private System.Windows.Forms.TextBox fileTextBox;
-    private System.Windows.Forms.Button storeDataButton;
-    private System.Windows.Forms.Label dataTypeLabel;
-    private System.Windows.Forms.Label fileLabel;
-    private System.Windows.Forms.OpenFileDialog openFileDialog;
+    private AlgorithmDataView algorithmDataView;
 
   }
Index: /branches/OKB/HeuristicLab.Clients.OKB-3.3/Views/AlgorithmView.cs
===================================================================
--- /branches/OKB/HeuristicLab.Clients.OKB-3.3/Views/AlgorithmView.cs	(revision 4480)
+++ /branches/OKB/HeuristicLab.Clients.OKB-3.3/Views/AlgorithmView.cs	(revision 4481)
@@ -26,5 +26,4 @@
 using HeuristicLab.MainForm;
 using HeuristicLab.MainForm.WindowsForms;
-using System.IO;
 
 namespace HeuristicLab.Clients.OKB {
@@ -45,5 +44,4 @@
       platformComboBox.DataSource = Administrator.Instance.Platforms.ToList();
       algorithmClassComboBox.DataSource = Administrator.Instance.AlgorithmClasses.ToList();
-      dataTypeComboBox.DataSource = Administrator.Instance.DataTypes.ToList();
     }
 
@@ -62,11 +60,12 @@
         platformComboBox.SelectedIndex = -1;
         algorithmClassComboBox.SelectedIndex = -1;
+        algorithmDataView.AlgorithmId = 0;
       } else {
         platformComboBox.SelectedItem = Administrator.Instance.Platforms.FirstOrDefault(p => p.Id == Content.PlatformId);
         algorithmClassComboBox.SelectedItem = Administrator.Instance.AlgorithmClasses.FirstOrDefault(a => a.Id == Content.AlgorithmClassId);
+        algorithmDataView.AlgorithmId = Content.Id;
       }
       usersListBox.DataSource = null;
-      fileTextBox.Text = "";
-      dataTypeComboBox.SelectedIndex = -1;
+      algorithmDataView.Content = null;
     }
 
@@ -78,5 +77,5 @@
       storeUsersButton.Enabled = usersListBox.DataSource != null;
       usersListBox.Enabled = usersListBox.DataSource != null;
-      storeDataButton.Enabled = !string.IsNullOrEmpty(fileTextBox.Text) && dataTypeComboBox.SelectedIndex != -1;
+      algorithmDataView.Enabled = Content != null;
     }
 
@@ -119,5 +118,5 @@
     }
     private void storeUsersButton_Click(object sender, System.EventArgs e) {
-      if (Administrator.Instance.StoreAlgorithmUsers(Content.Id, usersListBox.SelectedItems.Cast<User>().Select(u => u.Id).ToArray()))
+      if (Administrator.Instance.UpdateAlgorithmUsers(Content.Id, usersListBox.SelectedItems.Cast<User>().Select(u => u.Id).ToArray()))
         storeUsersButton.Enabled = false;
     }
@@ -125,29 +124,4 @@
       storeUsersButton.Enabled = true;
     }
-
-    private void storeDataButton_Click(object sender, EventArgs e) {
-      AlgorithmData data = new AlgorithmData();
-      data.AlgorithmId = Content.Id;
-      data.DataTypeId = ((DataType)dataTypeComboBox.SelectedItem).Id;
-
-      using (FileStream stream = new FileStream(fileTextBox.Text, FileMode.Open, FileAccess.Read)) {
-        byte[] bytes = new byte[stream.Length];
-        stream.Read(bytes, 0, bytes.Length);
-        stream.Close();
-        data.Data = bytes;
-      }
-
-      if (Administrator.Instance.StoreAlgorithmData(data))
-        storeDataButton.Enabled = false;
-    }
-    private void openFileButton_Click(object sender, EventArgs e) {
-      if (openFileDialog.ShowDialog(this) == DialogResult.OK) {
-        fileTextBox.Text = openFileDialog.FileName;
-        storeDataButton.Enabled = true;
-      }
-    }
-    private void dataTypeComboBox_SelectedIndexChanged(object sender, EventArgs e) {
-      storeDataButton.Enabled = !string.IsNullOrEmpty(fileTextBox.Text);
-    }
   }
 }
Index: /branches/OKB/HeuristicLab.Clients.OKB-3.3/Views/ProblemClassCollectionView.Designer.cs
===================================================================
--- /branches/OKB/HeuristicLab.Clients.OKB-3.3/Views/ProblemClassCollectionView.Designer.cs	(revision 4481)
+++ /branches/OKB/HeuristicLab.Clients.OKB-3.3/Views/ProblemClassCollectionView.Designer.cs	(revision 4481)
@@ -0,0 +1,53 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Clients.OKB {
+  partial class ProblemClassCollectionView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing) {
+        if (components != null) components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      components = new System.ComponentModel.Container();
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+    }
+
+    #endregion
+  }
+}
Index: /branches/OKB/HeuristicLab.Clients.OKB-3.3/Views/ProblemClassCollectionView.cs
===================================================================
--- /branches/OKB/HeuristicLab.Clients.OKB-3.3/Views/ProblemClassCollectionView.cs	(revision 4481)
+++ /branches/OKB/HeuristicLab.Clients.OKB-3.3/Views/ProblemClassCollectionView.cs	(revision 4481)
@@ -0,0 +1,40 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Windows.Forms;
+using HeuristicLab.Core;
+using HeuristicLab.Core.Views;
+using HeuristicLab.MainForm;
+
+namespace HeuristicLab.Clients.OKB {
+  [View("ProblemClassCollection View")]
+  [Content(typeof(IItemCollection<ProblemClass>), true)]
+  public partial class ProblemClassCollectionView : ItemCollectionView<ProblemClass> {
+    public ProblemClassCollectionView() {
+      InitializeComponent();
+      itemsGroupBox.Text = "Problem Classes";
+    }
+
+    protected override ProblemClass CreateItem() {
+      return new ProblemClass();
+    }
+  }
+}
Index: /branches/OKB/HeuristicLab.Clients.OKB-3.3/Views/ProblemCollectionView.Designer.cs
===================================================================
--- /branches/OKB/HeuristicLab.Clients.OKB-3.3/Views/ProblemCollectionView.Designer.cs	(revision 4481)
+++ /branches/OKB/HeuristicLab.Clients.OKB-3.3/Views/ProblemCollectionView.Designer.cs	(revision 4481)
@@ -0,0 +1,53 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Clients.OKB {
+  partial class ProblemCollectionView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing) {
+        if (components != null) components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      components = new System.ComponentModel.Container();
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+    }
+
+    #endregion
+  }
+}
Index: /branches/OKB/HeuristicLab.Clients.OKB-3.3/Views/ProblemCollectionView.cs
===================================================================
--- /branches/OKB/HeuristicLab.Clients.OKB-3.3/Views/ProblemCollectionView.cs	(revision 4481)
+++ /branches/OKB/HeuristicLab.Clients.OKB-3.3/Views/ProblemCollectionView.cs	(revision 4481)
@@ -0,0 +1,40 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Windows.Forms;
+using HeuristicLab.Core;
+using HeuristicLab.Core.Views;
+using HeuristicLab.MainForm;
+
+namespace HeuristicLab.Clients.OKB {
+  [View("ProblemCollection View")]
+  [Content(typeof(IItemCollection<Problem>), true)]
+  public partial class ProblemCollectionView : ItemCollectionView<Problem> {
+    public ProblemCollectionView() {
+      InitializeComponent();
+      itemsGroupBox.Text = "Problems";
+    }
+
+    protected override Problem CreateItem() {
+      return new Problem();
+    }
+  }
+}
Index: /branches/OKB/HeuristicLab.Services.OKB.DataAccess/3.3/OKB.dbml
===================================================================
--- /branches/OKB/HeuristicLab.Services.OKB.DataAccess/3.3/OKB.dbml	(revision 4480)
+++ /branches/OKB/HeuristicLab.Services.OKB.DataAccess/3.3/OKB.dbml	(revision 4481)
@@ -30,5 +30,4 @@
       <Column Name="ProblemClassId" Type="System.Int64" DbType="BigInt NOT NULL" CanBeNull="false" />
       <Column Name="PlatformId" Type="System.Int64" DbType="BigInt NOT NULL" CanBeNull="false" />
-      <Column Name="SolutionRepresentationId" Storage="_SolutionRepresentationid" Type="System.Int64" DbType="BigInt NOT NULL" CanBeNull="false" />
       <Column Name="Name" Type="System.String" DbType="NVarChar(200) NOT NULL" CanBeNull="false" />
       <Column Name="Description" Type="System.String" DbType="NVarChar(MAX)" CanBeNull="true" />
